<template>
  <div class="view-table-content">
    <div class="view-dataSpecies-left">
      <MenuTree :currentNodeKey="currentNodeKey" nodeKey="id" :treedata="menuTreeData" @TreeNodeclick="treeNodeClick" v-bind="treeObj"> </MenuTree>
    </div>
    <div class="view-dataSpecies-right">
      <div class="view-dataType-title">
        <div class="view-dataType-title-btn">
          <el-button type="success" @click="openDialog()" :disabled="currentNode && !currentNode.type == 1">新增</el-button>
          <el-button type="warning" @click="remove(tableCheckItems)" :disabled="tableCheckItems.length == 0">删除</el-button>
        </div>
        <div class="view-dataType-title-search">
          <el-input placeholder="请输入关键字" v-model="keyWordData" class="input1">
            <el-button slot="append" icon="el-icon-search" @click="searchClick"></el-button>
          </el-input>
        </div>
      </div>
      <div class="view-dataType-table">
        <LTable ref="table" @selection-change="selection" :defaultFetch="false" :fetch="fetch" :columns="columns" :dataSource="tableData" :options="options" :pagination="tableRequset"></LTable>
      </div>
      <!-- 添加或修改作训数据对话框 -->
      <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="600px" :before-close="handleClose">
        <el-form ref="form" :model="form" label-width="80px">
          <el-form-item label="名称" prop="name">
            <el-input v-model="form.name" placeholder="请输入名称" />
          </el-form-item>
          <el-form-item label="作者" prop="author">
            <el-input v-model="form.author" placeholder="请输入作者" />
          </el-form-item>
          <el-form-item label="出版时间" prop="publicationDate">
            <el-date-picker clearable v-model="form.publicationDate" type="date" value-format="yyyy-MM-dd" placeholder="请选择出版时间"> </el-date-picker>
          </el-form-item>
          <el-form-item label="资料类型" prop="type">
            <el-input v-model="form.type" placeholder="请输入资料类型" />
          </el-form-item>
          <el-form-item label="机型" prop="aircaftModelId">
            <el-select v-model="form.aircaftModelId" placeholder="请选择机型" disabled>
              <el-option v-for="item in aircaftModelAll" :key="item.aircaftModelId" :label="item.aircaftModelName" :value="item.aircaftModelId"> </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="文件Id" prop="ossId">
            <!-- <el-input v-model="form.ossId" placeholder="请输入文件Id" /> -->
            <FileUpload :fileSize="500" :fileType="['pdf', 'docx']" />
          </el-form-item>
        </el-form>

        <span slot="footer" class="dialog-footer">
          <el-button @click="handleClose">取 消</el-button>
          <el-button type="primary" @click="submit">确 定</el-button>
        </span>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import { getTechnicalDoc, addTechnicalDoc, updateTechnicalDoc, removeTechnicalDoc } from '@/api/als/technicalDoc'
import { getAircaftCatalogTree, getAircaftTypeAndModelTree } from '@/api/als/sideTree'
import { getAircaftModelAll } from '@/api/als/aircraft'
import { deepClone, debounce } from '@/utils/index'
import FileUpload from '@/views/als/components/FileUpload'

export default {
  name: 'TrainingData',
  components: { FileUpload },
  data() {
    // 这里存放数据
    return {
      dialogTitle: '新增',
      dialogVisible: false,
      keyWordData: '',
      aircaftModelIdList: [],
      currentNodeKey: null,
      currentNode: null,
      menuTreeData: [],
      treeObj: {
        title: '所属机种',
        activityheight: '275px',
        searchIcon: false,
        configure: {
          children: 'children',
          label: 'label'
        }
      },
      typeTree: {
        children: 'children',
        label: 'label'
      },
      searchValue: '',
      columns: [
        { prop: 'id', label: '编号' },
        {
          prop: 'name',
          label: '名称'
        },
        {
          prop: 'author',
          label: '作者'
        },
        {
          prop: 'publicationDate',
          label: '出版时间'
        },
        {
          prop: 'type',
          label: '资料类型'
        },
        {
          prop: 'aircaftModelId',
          label: '所属机型',
          render: (h, params) => {
            const matchedItem = this.aircaftModelAll.find((item) => params.row.aircraftType === item.aircaftModelId)
            if (matchedItem) {
              return h('span', matchedItem.aircaftModelName)
            } else {
              return h('span', {}, '')
            }
          }
        },
        {
          prop: 'ossId',
          label: '文件Id'
        },
        {
          button: true,
          label: '操作',
          width: '240px',
          group: [
            {
              name: '编辑',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                this.handUpdate(row)
              }
            },
            {
              name: '删除',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                this.remove([row])
              }
            }
          ]
        }
      ],
      options: {
        stripe: true, // 斑马纹
        mutiSelect: true, // 多选框
        index: false, // 显示序号， 多选则 mutiSelect
        loading: false, // 表格动画
        initTable: false, // 是否一挂载就加载数据
        border: true,
        height: 'calc(100vh - 300px)'
      },
      tableCheckItems: [],
      tableData: [],
      tableRequset: {
        total: 0,
        pageIndex: 1,
        pageSize: 10,
        searchValue: ''
      },
      form: {
        id: '',
        name: '',
        author: '',
        publicationDate: '',
        aircaftModelId: '',
        type: '',
        ossId: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      },
      debounceFn: debounce(this.fetch, 500),
      aircaftModelAll: []
    }
  },
  watch: {
    keyWord() {
      this.tableRequset.pageIndex = 1
      this.debounceFn()
    }
  },
  mounted() {
    this.getAircaftTypeAndModelTreeAPI()
  },
  methods: {
    async getAircaftTypeAndModelTreeAPI(params) {
      const { data } = await getAircaftTypeAndModelTree(params)
      this.menuTreeData = data
      const getAircaftModelAllParams = {
        aircaftTypeCode: '',
        aircaftTypeId: '',
        queryParam: ''
      }
      const { data: data1 } = await getAircaftModelAll(getAircaftModelAllParams)
      this.aircaftModelAll = data1
      if (data.length) {
        this.currentNodeKey = data[0].id
        this.currentNode = data[0]
        this.getTechnicalDocAPI()
      }
    },

    async removeTechnicalDocAPI(params) {
      try {
        const { code } = await removeTechnicalDoc(params)
        if (code === 200) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          await this.getTechnicalDocAPI(this.currentNodeKey === 'quanbu' ? null : this.currentNodeKey)
          this.handleClose()
        }
      } catch (error) {}
    },

    getTreeLeafData(list) {
      const newArr = []
      function getLeaf(data, arr) {
        data.forEach((e) => {
          if (e.type === 1) {
            arr.push(e)
          }
          if (e.children.length) {
            getLeaf(e.children, arr)
          }
        })
      }
      getLeaf(list, newArr)
      return newArr
    },

    async getTechnicalDocAPI(params) {
      if (this.$refs.table) this.$refs.table.clearSelection()
      const { keyWord } = this
      const { pageSize, pageIndex } = this.tableRequset
      const {
        data: { list, total }
      } = await getTechnicalDoc({ pageSize, pageIndex, aircaftModelId: params })
      this.tableData = list
      this.tableRequset.total = total
    },

    fetch() {
      this.getTechnicalDocAPI(this.currentNodeKey)
    },

    async searchClick() {
      // this.getTechnicalDocAPI(this.currentNodeKey)
      if (this.keyWordData) {
        const {
          data: { list, total }
        } = await getTechnicalDoc({ aircaftModelId: this.currentNodeKey, name: this.keyWordData })
        this.tableData = list
        this.tableRequset.total = total
      } else {
        this.getTechnicalDocAPI(this.currentNodeKey)
      }
    },

    async addTechnicalDocAPI() {
      try {
        delete this.form.aircaftModelName
        const { code } = await addTechnicalDoc({ ...this.form })
        if (code === 200) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getTechnicalDocAPI(this.currentNodeKey)
        }
      } catch (error) {}
    },

    async updateTechnicalDocAPI() {
      try {
        const { code } = await updateTechnicalDoc({ ...this.form })
        if (code === 200) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getTechnicalDocAPI(this.currentNodeKey)
        }
      } catch (error) {}
    },

    treeNodeClick(data) {
      this.$refs.table.clearSelection()
      this.currentNodeKey = this.form.aircaftModelId = data.id
      this.currentNode = data
      this.getTechnicalDocAPI(this.currentNodeKey)
    },

    openDialog() {
      this.dialogTitle = '新增'
      this.dialogVisible = true
      this.form.aircaftModelId = this.currentNodeKey
    },

    handleClose() {
      this.dialogVisible = false
      this.form = {
        id: '',
        name: '',
        author: '',
        publicationDate: '',
        type: '',
        ossId: '',
        aircaftModelId: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      }
    },

    handUpdate(row) {
      this.dialogTitle = '编辑'
      this.form = deepClone(row)
      this.dialogVisible = true
    },

    submit() {
      switch (this.dialogTitle) {
        case '编辑':
          this.updateTechnicalDocAPI()
          this.handleClose()
          break
        case '新增':
          this.addTechnicalDocAPI()
          this.handleClose()
          break
      }
    },

    selection(val) {
      this.tableCheckItems = val
    },

    remove(row) {
      this.$confirm('是否删除该机种', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.removeTechnicalDocAPI(row.map((e) => e.id))
        })
        .catch(() => {})
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../index.scss';
</style>
